#include <QTRSensors.h>
#define NUM_SENSORS   6   // number of sensors used
#define TIMEOUT       2500  // waits for 2500 microseconds for sensor outputs to go low
#define EMITTER_PIN   2     // emitter is controlled by digital pin 2
QTRSensorsRC qtrrc((unsigned char[]) {14,15,16,17,18,19},
  NUM_SENSORS, TIMEOUT, EMITTER_PIN);
unsigned int sensorValues[NUM_SENSORS];
int leftCenterReading;
int leftNearReading;
int leftFarReading;
int rightCenterReading;
int rightNearReading;                      
int rightFarReading;
int leftNudge;
int replaystage;
int rightNudge;
#define leapTime 150
#define leftMotor1  11
#define leftMotor2  10
#define rightMotor1 9
#define rightMotor2 6
#define led 13
char path[40] = {};
int pathLength;
int readLength;
void setup(){


  pinMode(leftMotor1, OUTPUT);
  pinMode(leftMotor2, OUTPUT);
  pinMode(rightMotor1, OUTPUT);
  pinMode(rightMotor2, OUTPUT);
  pinMode(led, OUTPUT);

  pinMode(13, OUTPUT);
  digitalWrite(13, HIGH);    // turn on Arduino's LED to indicate we are in calibration mode
  for (int i = 0; i < 400; i++)  // make the calibration take about 10 seconds
  {
    qtrrc.calibrate();       // reads all sensors 10 times at 2500 us per read (i.e. ~25 ms per call)
  }
  digitalWrite(13, LOW);     // turn off Arduino's LED to indicate we are through with calibration

  Serial.begin(9600);
  digitalWrite(led, LOW);


}
void loop(){
  unsigned int position = qtrrc.readLine(sensorValues);
 readSensors();  
 /*Serial.print(leftFarReading);
     Serial.print('\t');
 Serial.print(leftNearReading);
     Serial.print('\t');
 Serial.print(leftCenterReading);
     Serial.print('\t');
 Serial.print(rightCenterReading);
     Serial.print('\t');
 Serial.print(rightNearReading);
     Serial.print('\t');
 Serial.print(rightFarReading);
 

  Serial.println();   
                 */                                                              
 
if(leftFarReading>200 && rightFarReading>200 && //center sensors on
   (leftCenterReading<200 || rightCenterReading<200) ){ 
    straight();                                                                                      
  }
 
  else{                                                                                              
    leftHandWall();                                                                                   
  }


}
void readSensors(){
  
  leftCenterReading  = sensorValues[3];
  leftNearReading    = sensorValues[4];
  leftFarReading     = sensorValues[5];
  rightCenterReading = sensorValues[2];
  rightNearReading   = sensorValues[1];
  rightFarReading    = sensorValues[0];

}


void leftHandWall(){
          

  if( leftFarReading<200 && rightFarReading<200){//to check maze is finishef or not
    analogWrite(leftMotor1,100);
    analogWrite(leftMotor2, 0);
    analogWrite(rightMotor1,100);
    analogWrite(rightMotor2, 0);
    delay(150);
    readSensors();
    
    if(leftFarReading<200 && rightFarReading<200){
      done();
    }
    if(leftFarReading>200 && rightFarReading>200){ 
      turnLeft();
    }
    
  }
  
  if(leftFarReading<200){ // if you can turn left then turn left
    analogWrite(leftMotor1,100);
    analogWrite(leftMotor2, 0);
    analogWrite(rightMotor1,100);
    analogWrite(rightMotor2, 0);
    delay(150);
    readSensors();
      
      if(leftFarReading>200 && rightFarReading>200){
        turnLeft();
      }
      else{
        done();
      }
  }
   
  if(rightFarReading<200){//right
    analogWrite(leftMotor1,100);
    analogWrite(leftMotor2,0);
    analogWrite(rightMotor1,100);
    analogWrite(rightMotor2,0);
    delay(30);
    readSensors();
    
    if(leftFarReading<200){//left
      delay(leapTime-30);
      readSensors();
      
      if(rightFarReading<200 && leftFarReading<200){
        done();
      }
      else{
        turnLeft();
        return;
      }
    }
    delay(leapTime-30);
    readSensors();
    if(leftFarReading>200 && leftCenterReading>200 &&
      rightCenterReading>200 && rightFarReading>200){
      turnRight();
      return;
    }
    path[pathLength]='S';
  //  Serial.println("s");
    pathLength++;
    //Serial.print("Path length: ");
    //Serial.println(pathLength);
    if(path[pathLength-2]=='B'){
    //Serial.println("shortening path");
    shortPath();
     }
    straight();
  }
  readSensors();
  if(leftFarReading>200 && leftCenterReading>200 && rightCenterReading>200 
    && rightFarReading>200 && leftNearReading>200 && rightNearReading>200)
    {
    turnAround();
  }
  
}
void done(){
  digitalWrite(leftMotor1, LOW);
    digitalWrite(leftMotor2, LOW);
    digitalWrite(rightMotor1, LOW);
    digitalWrite(rightMotor2, LOW);
  replaystage=1;
  path[pathLength]='D';
  pathLength++;
 while(leftFarReading<200){
   digitalWrite(led, HIGH);
  
 }
 delay(5000);
  replay();
}

void turnLeft()
{
  Serial.println("Left");
  while((rightCenterReading)<200 ||(leftCenterReading)<200){
     analogWrite(leftMotor1, 0);
    analogWrite(leftMotor2, 150);
    analogWrite(rightMotor1, 150);
    analogWrite(rightMotor2, 0);
    delay(2);
     digitalWrite(leftMotor1, LOW);
    digitalWrite(leftMotor2, LOW);
    digitalWrite(rightMotor1, LOW);
    digitalWrite(rightMotor2, LOW);
    delay(1);
  }
    
  while(rightCenterReading>200 ) {
    analogWrite(leftMotor1, 0);
    analogWrite(leftMotor2, 150);
    analogWrite(rightMotor1, 150);
    analogWrite(rightMotor2, 0);
    delay(2);
    digitalWrite(leftMotor1, LOW);
    digitalWrite(leftMotor2, LOW);
    digitalWrite(rightMotor1, LOW);
    digitalWrite(rightMotor2, LOW);
    delay(1);
  }
 
  if(replaystage==0){
    path[pathLength]='L';
  //  Serial.println("l");
    pathLength++;
    //Serial.print("Path length: ");
    //Serial.println(pathLength);
      if(path[pathLength-2]=='B'){
    //Serial.println("shortening path");
        shortPath();
      }
  }
}

void turnRight(){
Serial.println("Right");
    
  while(rightCenterReading<200){
    analogWrite(leftMotor1, 150);
    analogWrite(leftMotor2, 0);
    analogWrite(rightMotor1, 0);
    analogWrite(rightMotor2, 150);
    delay(2);
     digitalWrite(leftMotor1, LOW);
    digitalWrite(leftMotor2, LOW);
    digitalWrite(rightMotor1, LOW);
    digitalWrite(rightMotor2, LOW);
    delay(1);
  }
   while(rightCenterReading>200){
     analogWrite(leftMotor1, 150);
    analogWrite(leftMotor2, 0);
    analogWrite(rightMotor1, 0);
    analogWrite(rightMotor2, 150);
    delay(2);
     digitalWrite(leftMotor1, LOW);
    digitalWrite(leftMotor2, LOW);
    digitalWrite(rightMotor1, LOW);
    digitalWrite(rightMotor2, LOW);
    delay(1);
  }
   while(leftCenterReading>200){
analogWrite(leftMotor1, 150);
  analogWrite(leftMotor2,0);
    analogWrite(rightMotor1,10);
    analogWrite(rightMotor2,150);
    delay(2);
    digitalWrite(leftMotor1, LOW);
    digitalWrite(leftMotor2, LOW);
    digitalWrite(rightMotor1, LOW);
    digitalWrite(rightMotor2, LOW);
    delay(1);
  }
  
  if(replaystage==0){
  path[pathLength]='R';
 // Serial.println("r");
  pathLength++;
 // Serial.print("Path length: ");
  //Serial.println(pathLength);
    if(path[pathLength-2]=='B'){
    //  Serial.println("shortening path");
      shortPath();
    }
  }
 
}

void straight(){
  Serial.println("forward");
  if(leftCenterReading>200){
   analogWrite(leftMotor1, 180);
    analogWrite(leftMotor2, 0);
    analogWrite(rightMotor1, 180);
    analogWrite(rightMotor2, 0);
    delay(1);
    digitalWrite(leftMotor1, HIGH);
    digitalWrite(leftMotor2, LOW);
    digitalWrite(rightMotor1, LOW);
    digitalWrite(rightMotor2, LOW);
    delay(5);
    return;
  }
  if(rightCenterReading>200){
   analogWrite(leftMotor1, 180);
    analogWrite(leftMotor2, 0);
    analogWrite(rightMotor1, 180);
    analogWrite(rightMotor2, 0);
    delay(1);
    digitalWrite(leftMotor1, LOW);
    digitalWrite(leftMotor2, LOW);
    digitalWrite(rightMotor1, HIGH);
    digitalWrite(rightMotor2, LOW);
    delay(5);
    return;
  }
  
   analogWrite(leftMotor1, 180);
    analogWrite(leftMotor2, 0);
    analogWrite(rightMotor1, 180);
    analogWrite(rightMotor2, 0);
    delay(4);
    digitalWrite(leftMotor1, LOW);
    digitalWrite(leftMotor2, LOW);
    digitalWrite(rightMotor1, LOW);
    digitalWrite(rightMotor2, LOW);
    delay(1);
  
}

void turnAround(){
  Serial.println("round");
    analogWrite(leftMotor1, 180);
    analogWrite(leftMotor2, 0);
    analogWrite(rightMotor1,180);
    analogWrite(rightMotor2, 0);
    delay(70);
    
   while(rightCenterReading>200){
     analogWrite(leftMotor1, 0);
    analogWrite(leftMotor2, 200);
    analogWrite(rightMotor1, 200);
    analogWrite(rightMotor2, 0);
    delay(2);
     digitalWrite(leftMotor1, LOW);
    digitalWrite(leftMotor2, LOW);
    digitalWrite(rightMotor1, LOW);
    digitalWrite(rightMotor2, LOW);
    delay(1);
  }
  path[pathLength]='B';
  pathLength++;
  straight();
  Serial.println("b");
  Serial.print("Path length: ");
  Serial.println(pathLength);
}

void shortPath(){
 int shortDone=0;
  if(path[pathLength-3]=='L' && path[pathLength-1]=='R'){
    pathLength-=3;
    path[pathLength]='B';
  Serial.println("test1");
    shortDone=1;
  }
   
  if(path[pathLength-3]=='L' && path[pathLength-1]=='S' && shortDone==0){
    pathLength-=3;
    path[pathLength]='R';
  Serial.println("test2");
    shortDone=1;
  }
   
  if(path[pathLength-3]=='R' && path[pathLength-1]=='L' && shortDone==0){
    pathLength-=3;
    path[pathLength]='B';
  Serial.println("test3");
    shortDone=1;
  }
  
   
  if(path[pathLength-3]=='S' && path[pathLength-1]=='L' && shortDone==0){
    pathLength-=3;
    path[pathLength]='R';
  Serial.println("test4");
    shortDone=1;
  }
     
  if(path[pathLength-3]=='S' && path[pathLength-1]=='S' && shortDone==0){
    pathLength-=3;
    path[pathLength]='B';
  Serial.println("test5");
    shortDone=1;
  }
    if(path[pathLength-3]=='L' && path[pathLength-1]=='L' && shortDone==0){
    pathLength-=3;
    path[pathLength]='S';
  Serial.println("test6");
    shortDone=1;
  }
  
  path[pathLength+1]='D';
  path[pathLength+2]='D';
  pathLength++;
  Serial.print("Path length: ");
  Serial.println(pathLength);
  printPath();
}




void printPath(){
  Serial.println("+++++++++++++++++");
  int x;
  while(x<=pathLength){
  Serial.println(path[x]);
  x++;
  }
  Serial.println("+++++++++++++++++");
}


void replay(){
   readSensors();
  if(leftFarReading>200 && rightFarReading>200){
    straight();
  }
  else{
    if(path[readLength]=='D'){
       digitalWrite(leftMotor1, HIGH);
    digitalWrite(leftMotor2, LOW);
    digitalWrite(rightMotor1, HIGH);
  digitalWrite(rightMotor2, LOW);
    delay(180);
    digitalWrite(leftMotor1, LOW);
    digitalWrite(leftMotor2, LOW);
    digitalWrite(rightMotor1, LOW);
    digitalWrite(rightMotor2, LOW);
      endMotion();
    }
    if(path[readLength]=='L'){
     analogWrite(leftMotor1, 100);
     analogWrite(leftMotor2, 0);
    analogWrite(rightMotor1, 100);
    analogWrite(rightMotor2,0);
    delay(leapTime);
      turnLeft();
    }
    if(path[readLength]=='R'){
       analogWrite(leftMotor1, 100);
    analogWrite(leftMotor2, 0);
    analogWrite(rightMotor1, 100);
    analogWrite(rightMotor2, 0);
    delay(leapTime);
    turnRight();
    }
    if(path[readLength]=='S'){
       analogWrite(leftMotor1, 180);
    analogWrite(leftMotor2, 0);
    analogWrite(rightMotor1,180);
    analogWrite(rightMotor2,0);
    delay(leapTime);
    straight();
    }
    
    readLength++;
  }
    
  replay();
  
}

void endMotion(){
    digitalWrite(led, LOW);
    delay(500);
    digitalWrite(led, HIGH);
    delay(200);
      digitalWrite(led, LOW);
    delay(200);
    digitalWrite(led, HIGH);
    delay(500);
  endMotion();
}

